# FeedClient

Ensi Feed

This PHP package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Build package: org.openapitools.codegen.languages.PhpClientCodegen
For more information, please visit [https://ensi.tech/contacts](https://ensi.tech/contacts)

## Requirements

PHP 5.5 and later

## Installation & Usage

### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```json
{
  "repositories": [
    {
      "type": "vcs",
      "url": "https://gitlab.com/greensight/ensi/catalog/clients/feed-client-php.git"
    }
  ],
  "require": {
    "ensi/feed-client": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/FeedClient/vendor/autoload.php');
```

## Tests

To run the unit tests:

```bash
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');



$apiInstance = new Ensi\FeedClient\Api\ActualCategoryPropertiesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$search_actual_category_properties_request = new \Ensi\FeedClient\Dto\SearchActualCategoryPropertiesRequest(); // \Ensi\FeedClient\Dto\SearchActualCategoryPropertiesRequest | 

try {
    $result = $apiInstance->searchActualCategoryProperties($search_actual_category_properties_request);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ActualCategoryPropertiesApi->searchActualCategoryProperties: ', $e->getMessage(), PHP_EOL;
}

?>
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost/api/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ActualCategoryPropertiesApi* | [**searchActualCategoryProperties**](docs/Api/ActualCategoryPropertiesApi.md#searchactualcategoryproperties) | **POST** /categories/actual-category-properties:search | Search for objects of type ActualCategoryProperty
*CloudIntegrationsApi* | [**createCloudIntegration**](docs/Api/CloudIntegrationsApi.md#createcloudintegration) | **POST** /cloud/cloud-integrations | Создание объекта типа CloudIntegration
*CloudIntegrationsApi* | [**getCloudIntegration**](docs/Api/CloudIntegrationsApi.md#getcloudintegration) | **GET** /cloud/cloud-integrations | Получение объекта типа CloudIntegration
*CloudIntegrationsApi* | [**patchCloudIntegration**](docs/Api/CloudIntegrationsApi.md#patchcloudintegration) | **PATCH** /cloud/cloud-integrations | Изменение объектов типа CloudIntegration
*CommonApi* | [**migrateEntities**](docs/Api/CommonApi.md#migrateentities) | **POST** /common/entities:migrate | Start synchronization of data objects from master services
*FeedSettingsApi* | [**createFeedSettings**](docs/Api/FeedSettingsApi.md#createfeedsettings) | **POST** /feeds/feed-settings | Создание объекта типа FeedSettings
*FeedSettingsApi* | [**getFeedSettings**](docs/Api/FeedSettingsApi.md#getfeedsettings) | **GET** /feeds/feed-settings/{id} | Получение объекта типа FeedSettings
*FeedSettingsApi* | [**patchFeedSettings**](docs/Api/FeedSettingsApi.md#patchfeedsettings) | **PATCH** /feeds/feed-settings/{id} | Обновления части полей объекта типа FeedSettings
*FeedSettingsApi* | [**searchFeedSettings**](docs/Api/FeedSettingsApi.md#searchfeedsettings) | **POST** /feeds/feed-settings:search | Поиск объектов типа FeedSettings
*FeedsApi* | [**getFeed**](docs/Api/FeedsApi.md#getfeed) | **GET** /feeds/feeds/{id} | Получение объекта типа Feed
*FeedsApi* | [**searchFeeds**](docs/Api/FeedsApi.md#searchfeeds) | **POST** /feeds/feeds:search | Поиск объектов типа Feed


## Documentation For Models

 - [ActualCategoryProperty](docs/Model/ActualCategoryProperty.md)
 - [ActualCategoryPropertyReadonlyProperties](docs/Model/ActualCategoryPropertyReadonlyProperties.md)
 - [CloudIntegration](docs/Model/CloudIntegration.md)
 - [CloudIntegrationFillableProperties](docs/Model/CloudIntegrationFillableProperties.md)
 - [CloudIntegrationReadonlyProperties](docs/Model/CloudIntegrationReadonlyProperties.md)
 - [CloudIntegrationResponse](docs/Model/CloudIntegrationResponse.md)
 - [CreateCloudIntegrationRequest](docs/Model/CreateCloudIntegrationRequest.md)
 - [EmptyDataResponse](docs/Model/EmptyDataResponse.md)
 - [Error](docs/Model/Error.md)
 - [ErrorResponse](docs/Model/ErrorResponse.md)
 - [ErrorResponse2](docs/Model/ErrorResponse2.md)
 - [Feed](docs/Model/Feed.md)
 - [FeedIncludes](docs/Model/FeedIncludes.md)
 - [FeedPlatformEnum](docs/Model/FeedPlatformEnum.md)
 - [FeedReadonlyProperties](docs/Model/FeedReadonlyProperties.md)
 - [FeedResponse](docs/Model/FeedResponse.md)
 - [FeedSettings](docs/Model/FeedSettings.md)
 - [FeedSettingsFillableProperties](docs/Model/FeedSettingsFillableProperties.md)
 - [FeedSettingsForCreate](docs/Model/FeedSettingsForCreate.md)
 - [FeedSettingsForPatch](docs/Model/FeedSettingsForPatch.md)
 - [FeedSettingsIncludes](docs/Model/FeedSettingsIncludes.md)
 - [FeedSettingsReadonlyProperties](docs/Model/FeedSettingsReadonlyProperties.md)
 - [FeedSettingsResponse](docs/Model/FeedSettingsResponse.md)
 - [FeedTypeEnum](docs/Model/FeedTypeEnum.md)
 - [File](docs/Model/File.md)
 - [PaginationTypeCursorEnum](docs/Model/PaginationTypeCursorEnum.md)
 - [PaginationTypeEnum](docs/Model/PaginationTypeEnum.md)
 - [PaginationTypeOffsetEnum](docs/Model/PaginationTypeOffsetEnum.md)
 - [PatchCloudIntegrationRequest](docs/Model/PatchCloudIntegrationRequest.md)
 - [RequestBodyCursorPagination](docs/Model/RequestBodyCursorPagination.md)
 - [RequestBodyOffsetPagination](docs/Model/RequestBodyOffsetPagination.md)
 - [RequestBodyPagination](docs/Model/RequestBodyPagination.md)
 - [ResponseBodyCursorPagination](docs/Model/ResponseBodyCursorPagination.md)
 - [ResponseBodyOffsetPagination](docs/Model/ResponseBodyOffsetPagination.md)
 - [ResponseBodyPagination](docs/Model/ResponseBodyPagination.md)
 - [SearchActualCategoryPropertiesRequest](docs/Model/SearchActualCategoryPropertiesRequest.md)
 - [SearchActualCategoryPropertiesResponse](docs/Model/SearchActualCategoryPropertiesResponse.md)
 - [SearchFeedSettingsRequest](docs/Model/SearchFeedSettingsRequest.md)
 - [SearchFeedSettingsResponse](docs/Model/SearchFeedSettingsResponse.md)
 - [SearchFeedsRequest](docs/Model/SearchFeedsRequest.md)
 - [SearchFeedsResponse](docs/Model/SearchFeedsResponse.md)
 - [SearchFeedsResponseMeta](docs/Model/SearchFeedsResponseMeta.md)


## Documentation For Authorization

All endpoints do not require authorization.

## Author

mail@greensight.ru

