<?php

namespace Ensi\FeedClient;

class FeedClientProvider
{
    /** @var string[] */
    public static $apis = [
        '\Ensi\FeedClient\Api\ActualCategoryPropertiesApi',
        '\Ensi\FeedClient\Api\CloudIntegrationsApi',
        '\Ensi\FeedClient\Api\FeedSettingsApi',
        '\Ensi\FeedClient\Api\CommonApi',
        '\Ensi\FeedClient\Api\FeedsApi',
    ];

    /** @var string[] */
    public static $dtos = [
        '\Ensi\FeedClient\Dto\RequestBodyPagination',
        '\Ensi\FeedClient\Dto\FeedSettingsResponse',
        '\Ensi\FeedClient\Dto\CreateCloudIntegrationRequest',
        '\Ensi\FeedClient\Dto\SearchFeedsRequest',
        '\Ensi\FeedClient\Dto\FeedResponse',
        '\Ensi\FeedClient\Dto\Error',
        '\Ensi\FeedClient\Dto\SearchFeedsResponse',
        '\Ensi\FeedClient\Dto\FeedSettingsFillableProperties',
        '\Ensi\FeedClient\Dto\SearchFeedsResponseMeta',
        '\Ensi\FeedClient\Dto\RequestBodyOffsetPagination',
        '\Ensi\FeedClient\Dto\PaginationTypeEnum',
        '\Ensi\FeedClient\Dto\FeedReadonlyProperties',
        '\Ensi\FeedClient\Dto\File',
        '\Ensi\FeedClient\Dto\SearchActualCategoryPropertiesRequest',
        '\Ensi\FeedClient\Dto\EmptyDataResponse',
        '\Ensi\FeedClient\Dto\FeedSettingsReadonlyProperties',
        '\Ensi\FeedClient\Dto\FeedPlatformEnum',
        '\Ensi\FeedClient\Dto\ResponseBodyPagination',
        '\Ensi\FeedClient\Dto\PaginationTypeCursorEnum',
        '\Ensi\FeedClient\Dto\FeedIncludes',
        '\Ensi\FeedClient\Dto\ResponseBodyCursorPagination',
        '\Ensi\FeedClient\Dto\CloudIntegrationFillableProperties',
        '\Ensi\FeedClient\Dto\PaginationTypeOffsetEnum',
        '\Ensi\FeedClient\Dto\ErrorResponse',
        '\Ensi\FeedClient\Dto\CloudIntegrationReadonlyProperties',
        '\Ensi\FeedClient\Dto\FeedSettingsForPatch',
        '\Ensi\FeedClient\Dto\SearchActualCategoryPropertiesResponse',
        '\Ensi\FeedClient\Dto\CloudIntegrationResponse',
        '\Ensi\FeedClient\Dto\SearchFeedSettingsResponse',
        '\Ensi\FeedClient\Dto\ResponseBodyOffsetPagination',
        '\Ensi\FeedClient\Dto\RequestBodyCursorPagination',
        '\Ensi\FeedClient\Dto\ModelInterface',
        '\Ensi\FeedClient\Dto\ActualCategoryProperty',
        '\Ensi\FeedClient\Dto\ActualCategoryPropertyReadonlyProperties',
        '\Ensi\FeedClient\Dto\CloudIntegration',
        '\Ensi\FeedClient\Dto\PatchCloudIntegrationRequest',
        '\Ensi\FeedClient\Dto\SearchFeedSettingsRequest',
        '\Ensi\FeedClient\Dto\FeedTypeEnum',
        '\Ensi\FeedClient\Dto\FeedSettingsIncludes',
        '\Ensi\FeedClient\Dto\ErrorResponse2',
        '\Ensi\FeedClient\Dto\Feed',
        '\Ensi\FeedClient\Dto\FeedSettingsForCreate',
        '\Ensi\FeedClient\Dto\FeedSettings',
    ];

    /** @var string */
    public static $configuration = '\Ensi\FeedClient\Configuration';
}
